/***************************************************************************
                          ToyMem_Internal.h  - Contains function headers
    that only ToyMem.c use.
                             -------------------
    begin                : Sat Jan 25 2003
    copyright            : (C) 2003 by Tyler Montbriand
    student #            : 200200370
    class                : CS330
    email                : tsm@accesscomm.ca 
***************************************************************************/
#ifndef __TOYMEM_INTERNAL_H__
#define __TOYMEM_INTERNAL_H__

#ifdef __cplusplus
  extern "C"
#endif/*__cplusplus*/

/*  Attempts to allocate a segment at the specified address.   */
ErrMessage_t TMM_AllocateSegmentAt(ToyMM *tmm, int pos, int size);

/*  Attempts to allocate a process at the specified address.  */
ErrMessage_t TMM_AllocateProcessAt(ToyMM *tm,int pID, int addr,int segs, int sizes[]);

/*  Attempts to allocate a process. */
ErrMessage_t TMM_AllocateProcess(ToyMM *tmm,int ID, int nSegs, int size[]);

/*  Attempts to allocate a segment.  Returns address on success, -1 on failure. */
int TMM_AllocateSegment(ToyMM *tmm, int size);

/*  Attempts to free a segment. */
ErrMessage_t TMM_FreeSegment(ToyMM *tmm, int pos, int size);

/*  Prints the specified area of memory, if used  */
void TMM_PrintMem(ToyMM *tmm, int addr);

#ifdef __cplusplus
    }
#endif/*__cplusplus*/

#endif/*__TOYMEM_INTERNAL_H__*/

