/***************************************************************************
                          ToyParseCmd.h  -  Function definitions,
    enumerated types, and string tables used for parsing Command files.
                             -------------------
    begin                : Sat Jan 25 2003
    copyright            : (C) 2003 by Tyler Montbriand
    student #            : 200200370
    class                : CS330
    email                : tsm@accesscomm.ca 
***************************************************************************/
#ifndef __TOYPARSECMD_H__
#define __TOYPARSECMD_H__

#ifdef __cplusplus
  extern "C" {
#endif/*__cplusplus*/

/* Types of valid commands. */
typedef enum CommandType_e
{
  COMMAND_ERROR    =-1
, COMMAND_LOADFILE = 0
, COMMAND_PRINTPROCESSTABLE
, COMMAND_PRINTPROCESSMEMORY
, COMMAND_STORE
, COMMAND_TERMINATEPROCESS
, COMMAND_PRINTALLMEMORY
, COMMAND_END
} CommandType_e;

/* Types of valid arguments. */
typedef enum ArgType_e
{
  TYPE_ERROR    =-1
, TYPE_PROCESS  = 0
, TYPE_COMMAND
, TYPE_ADDRESS
, TYPE_INTEGER
, TYPE_STRING
} ArgType_e;

/* String table associated with these commands/arguments */
const char **Arguments[];

int TMM_ParseFile(const char *fname, ToyMM *tm);

#ifdef __cplusplus
  }
#endif/*__cplusplus*/


#endif/*__TOYPARSECMD_H__*/
