/***************************************************************************
                          main.c
                          
    Main program that creates and manipulates a Toy Memory Manager.
    
                             -------------------
    begin                : Sat Jan 25 2003
    copyright            : (C) 2003 by Tyler Montbriand
    student #            : 200200370
    class                : CS330
    email                : tsm@accesscomm.ca 
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include "ToyMem.h"
#include "toyparse.h"
#include "ToyParseCmd.h"

int main(int argc, char *argv[])
{
  ToyMM *tm=NULL;
  
  BAIL_IF(argc<2,printf("Use commandline parameter 'toymem parse.txt [parse2.txt] ...'\n"),-1);

  tm=TMM_Create(1000);
  if(tm==NULL)
  {
    printf("Couldn't create ToyMM\n");
  }

  if(argc==2) /*  Backwards compatibility - don't print filenames when
                  there's only one parameter                            */
  {
    if(TMM_ParseFile(argv[1],tm)<0)
    {
      printf("---------------Couldn't parse %s-----------------\n",argv[1]);
    }    
  }
  else
  {
    int n;
    for(n=1; n<argc; n++)
    {
      printf("---------------Parsing %s------------------------\n",argv[n]);
      
      if(TMM_ParseFile(argv[n],tm)<0)
      {
        printf("---------------Couldn't parse %s-----------------\n",argv[n]);
      }
      else
      {
        printf("---------------Parsed %s-------------------------\n",argv[n]);
      }      
    }
  }
                  
    
  return EXIT_SUCCESS;
}


